﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace EsempioState.Step1
{
    public class ServicesProvider : IServicesProvider
    {
        #region IServicesProvider Members

        public IParallelogramma CreaRettangolo(double altezza, double larghezza)
        {
            Rettangolo rettangolo = new Rettangolo();
            rettangolo.Altezza = altezza;
            rettangolo.Larghezza = larghezza;
            return rettangolo;
        }

        public IParallelogramma CreaQuadrato(double lato)
        {
            Quadrato quadrato = new Quadrato();
            quadrato.Lato = lato;
            return quadrato;
        }

        public void Ridimensiona(IParallelogramma parallelogramma, Panel panel)
        {
            if (parallelogramma is Rettangolo)
            {
                ModificatoreDiDimensioni m = new ModificatoreDiDimensioni();
                m.Modifica((Rettangolo) parallelogramma, panel);
            }
        }

        #endregion
    }
}
