using System;
using System.Drawing;

namespace EsempioState.Step3
{
    partial class Parallelogramma : IParallelogramma
    {
        private double _altezza;
        private double _larghezza;
        private Tipo _tipo;

        public Parallelogramma(double altezza, double larghezza)
        {
            if (altezza <= 0)
                throw new ArgumentException("altezza <= 0");
            if (larghezza <= 0)
                throw new ArgumentException("larghezza <= 0");
            _altezza = altezza;
            _larghezza = larghezza;
            StateChanged();
        }

        public double Altezza
        {
            get { return _altezza; }
            set
            {
                if (value <= 0)
                    throw new ArgumentException("value <= 0");
                if (value != _altezza)
                {
                    _altezza = value;
                    StateChanged();
                }
            }
        }

        public double Larghezza
        {
            get { return _larghezza; }
            set
            {
                if (value <= 0)
                    throw new ArgumentException("value <= 0");
                if (value != _larghezza)
                {
                    _larghezza = value;
                    StateChanged();
                }
            }
        }

        public string Nome
        {
            get { return _tipo.Nome; }
        }

        public Color Colore
        {
            get { return _tipo.Colore; }
        }

        public int Timeout
        {
            get { return _tipo.Timeout; }
        }

        private void StateChanged()
        {
            _tipo = Tipo.DeterminaTipo(this);
        }
    }
}
